
Building:
---------

Prerequisites: You will need a C compiler capable of understanding C11, as well
as posix threads. 

We are including libyaml, libcyaml and libfabric as subtrees in our tree
and build these versions automatically with our make rules.

By default, the OFI conductor will be built. To enable the experimental other variants 
`--enable-mpi-conductor` or `--enable-smp-conductor` at configure time (INCOMPLETE).

For CRAY XC systems you should do
	module load rdma-credentials
	module load gni-headers
before configuring/building, to ensure libfabric will be built properly.

We are also including Version 0.1.0 of the Mamba library in deps/mamba, and a snapshot of MIO in deps/mio.

To use MIO you need to add the `--with-mio` flag at configure time, and have MERO installed on the system.

Then
```
autoreconf -ivf
./configure # CPPFLAGS="-I/path/to/ofi/include" LDFLAGS="-L/path/to/ofi/lib" 
make
```

Depending on which branch you build, the default configure argumenst may include options to enable the
gcc/llvm address sanitizer. To disable, please configure with
```
--disable-asan
```
If you have the address sanitizer enabled, that may (depending on the compiler) also turn on the leak checker, and since 
we are not fully memory leak-free at this point may trigger exit-time failures. To disable it, set the environment variable
```
LSAN_OPTIONS=detect_leaks=0
```


Cray-specific (jupiter)
-----------------------
Do not use one of the craype-network-ofi\* modules at this time.
Be sure to use CC=cc on the configure line.
libfabric builds nicely with CCE 9.0.

Subtree project updates
-----------------------
To update a dependency project (like mamba) subtree do 

```
git subtree pull --prefix=deps/mamba --squash git@gitlab.com:cerl/mamba.git master
```

CI
--

We are running gitlab-CI on the master, devel, and mvp branches.
If you notice issues you can run the gitlab CI locally using docker and the gitlab-runner tool.

Install docker and gitlab-runner, then run 

	docker-machine start
	eval $(docker-machine env)
	gitlab-runner exec docker build

Configuration is picked up from .gitlab-ci.yml

If `docker-machine start` fails try re-provisioning the docker machine, and/or reinstalling virtualbox.
